var InFormEnter = {

// my variables ------------------------------------------------------------
m_MarkerNumber : 0,
m_LastInput : null,
m_LastPopupMenu : null,
m_IsActiveMarker : false,
m_ActiveMarkers : [],
m_AutofloatStyleHide : "vertical-align:bottom; display: none; border: 0;",
// m_AutofloatStyleShow : "vertical-align:bottom; display: inline; border: 0; position:absolute; cursor:pointer;",
m_AutofloatStyleShow : "vertical-align:bottom; display: inline; border: 0; position:relative; cursor:pointer; z-index:999;",
m_LastFocusURL : "",

//------------------------------------------------------------------------------
OnMenuItemSelect: function(index, event)
{
 var menuTextItems = unescape(InFormEnterCommon.g_MenuSet).split("\n"); 
 if (index>=0 && index<menuTextItems.length)
 {
  var et_input = InFormEnter.m_LastInput;
  if (et_input)
  {
   var menu_value = "";
   var line = menuTextItems[index];
   if (line.length > 0)
   {
    line=InFormEnterCommon.HideSharp(line);
    var tmp = line.split ("#");
    if (tmp.length > 1)
    {
     var arraySize = tmp.length;
     if (arraySize == 2) // no macros
      menu_value = InFormEnterCommon.HideAt(InFormEnterCommon.UnhideSharp(tmp[0]));
     else
      menu_value = InFormEnterCommon.Macro(tmp[arraySize-2], true);
    }
    else 
     menu_value = InFormEnterCommon.HideAt(InFormEnterCommon.UnhideSharp(line));
   }
   
   var pos2Sel;
   if (event.ctrlKey)
   {
    var s1 = et_input.value.substr(0, et_input.selectionStart);
    var s2 = et_input.value.substr(et_input.selectionEnd);
    et_input.value = s1 + menu_value + s2;
    pos2Sel = s1.length + menu_value.length;
   }
   else
   {
    et_input.value = menu_value;
    pos2Sel = menu_value.length;
   }

   et_input.focus();
   et_input.setSelectionRange(pos2Sel,pos2Sel);
  }
  
 }
},

//------------------------------------------------------------------------------
Add2Profile: function()
{
  var et_input = InFormEnter.m_LastInput;

  if (et_input && et_input.value.length > 0)
  {
   var newEntry;
   if (et_input.selectionStart == et_input.selectionEnd)
    newEntry = et_input.value;
   else
    newEntry = et_input.value.substr(et_input.selectionStart, et_input.selectionEnd);

   var profileId = InFormEnterCommon.GetPrefInt("InFormEnter.ProfileCurrent", 1);
   InFormEnterCommon.g_MenuSet = unescape(InFormEnterCommon.GetPrefChar("InFormEnter."+profileId+".MenuSet", ""));
   InFormEnterCommon.g_MenuSet = newEntry.replace(/\n/g, "@@") + "\n" + InFormEnterCommon.g_MenuSet;
   InFormEnterCommon.g_Preferences.setCharPref("InFormEnter."+profileId+".MenuSet", escape(InFormEnterCommon.g_MenuSet));
  }
},

//------------------------------------------------------------------------------
CheckMarkerClick: function(event)
{
 var markerID = event.target.id.toString();
 var pos = markerID.indexOf ("_ife_marker_");
 if(pos != -1) // over ife marker
 {
  if(event.button == 0 ||  // left mouse click
     (event.button == 2 && InFormEnterCommon.g_MarkerRightClick == 1)) // right mouse click && show main menu
  {
   var et_marker = event.target;
   var et_input = et_marker.previousSibling;
   InFormEnter.m_LastInput = et_input;
   var maxlength = et_input.getAttribute("maxlength");

   et_input.focus();
   InFormEnterCommon.PopupFill('ife_popup_mi_hint', et_input.name, maxlength); 

   var pm1 = document.getElementById("ife_popup");
   InFormEnter.m_LastPopupMenu = pm1;
   pm1.showPopup(document.documentElement,
                 event.screenX + 7,                     // 14 is markers width
                 event.screenY - InFormEnterCommon.g_MenuItemsCount*10 - 20, // 20 is average menu item height
                 "popup","bottomleft","topleft");
  }

  if(event.button == 2 && InFormEnterCommon.g_MarkerRightClick == 0) // right mouse click && show profiles list
  {
   InFormEnterCommon.CheckDefaultProfile();

   var pm2 = document.getElementById("informenter-popup");
   InFormEnter.m_LastPopupMenu = pm2;
   pm2.showPopup(document.documentElement,
                 event.screenX,
                 event.screenY - 20,
                 "popup","bottomleft","topleft");
  }

  return false;
 }
},

//------------------------------------------------------------------------------
CheckMarkerDoubleClick: function(event)
{
 var markerID = event.target.id.toString();
 var pos = markerID.indexOf ("_ife_marker_");
 if(pos != -1) // over ife marker
 {
   var et_marker = event.target;
   if(et_marker.getAttribute("src").indexOf("informenter/skin/marker_inhistory_one.png") != -1)
   {
    var et_input = et_marker.previousSibling;
    et_input.value = InFormEnterCommon.GetCurrentProfileFirstItemFromFormCache (et_input.getAttribute("name"));
    InFormEnter.m_LastPopupMenu.hidePopup(); 
    return false;
  }
 }
},

//------------------------------------------------------------------------------
CheckAccelKey: function(event)
{
 var focused_input = document.commandDispatcher.focusedElement;
 if(!focused_input || !focused_input.nextSibling || !focused_input.nextSibling.id)
  return; // not input with markers

 var markerID = focused_input.nextSibling.id.toString();
 var pos = markerID.indexOf ("_ife_marker_");
 if(pos != -1) // in fine input
 {
   var et_input = focused_input;
   InFormEnter.m_LastInput = et_input;
   var maxlength = et_input.getAttribute("maxlength");

   InFormEnterCommon.PopupFill('ife_popup_mi_hint', et_input.name, maxlength); 

   var x,y;
   var tb = document.getElementById("navigator-toolbox");
   if (tb)
   {
    x = tb.boxObject.screenX; 
    y = tb.boxObject.screenY+tb.boxObject.height;
   }
   else
   {
    x = window.screenX;
    y = window.screenY+120;
   }

   var point = InFormEnterCommon.GetElementXY (et_input);
   x += (point.x - window._content.scrollX + 20); 
   y += (point.y - window._content.scrollY + et_input.clientHeight/2 - InFormEnterCommon.g_MenuItemsCount*10 - 20); // 20 is average menu item height;

   var pm = document.getElementById("ife_popup");
   pm.showPopup(document.documentElement,
                x,
                y,
                "popup","bottomleft","topleft");
 }

 return true;
},

//------------------------------------------------------------------------------
OnContextPopupShowing: function()
{
 var isHidden = true;
 if (InFormEnterCommon.g_IsOn && gContextMenu != null && gContextMenu.onTextInput)
 {
  isHidden = false;
  InFormEnter.m_LastInput = gContextMenu.target;
 }
 document.getElementById("ife_context").hidden = isHidden;
},

//------------------------------------------------------------------------------
OnContextSubPopupShowing: function()
{
 if (InFormEnterCommon.g_IsOn)
 {
  if (gContextMenu != null && gContextMenu.onTextInput && InFormEnter.m_LastInput != null)
  {
   var et_input = InFormEnter.m_LastInput;
   if (et_input != null)
   {
    var maxlength = et_input.getAttribute("maxlength");
    InFormEnterCommon.PopupFill('ife_context_popup_mi_hint', et_input.name, maxlength); 
   }
  }
 }
},

//------------------------------------------------------------------------------
OnOptions: function()
{
 window.openDialog("chrome://informenter/content/ife_options.xul","ife_options","chrome,centerscreen,modal,resizable");
 InFormEnterCommon.ReadState();
 InFormEnter.RemoveMarkers(window._content); // to change markers style
 InFormEnter.ProcessPage(null, "load");
},

//------------------------------------------------------------------------------
OnProfileCurrent: function(profileId)
{
 InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.ProfileCurrent", profileId);
 if(InFormEnterCommon.g_IsOn)
 {
  // to reload markers 
  InFormEnter.RemoveMarkers(window._content); 
  InFormEnter.ProcessPage(null, "load");
 }
},

//------------------------------------------------------------------------------
OnProfilesMenu: function(menu_item_id)
{
 InFormEnterCommon.CheckDefaultProfile();

 var profilesArr = InFormEnterCommon.GetPrefChar("InFormEnter.Profiles", "").split("\n");
 var profileCurrentId = InFormEnterCommon.GetPrefInt("InFormEnter.ProfileCurrent", 1);
 var mi_profile = document.getElementById(menu_item_id);

 // remove previous menu
 while (mi_profile.nextSibling != null)
  mi_profile.parentNode.removeChild (mi_profile.nextSibling);

 // template
 var mi_template = mi_profile.cloneNode(true);
 mi_template.setAttribute("hidden", false);

 // create new items
 var menuItemsCount = 0;
 for (var i=0; i<profilesArr.length; i++)
 {
  var profileData = profilesArr[i].split("\t");
  var mi_new = mi_template.cloneNode(true);
  mi_new.setAttribute("label", unescape(profileData[0]));
  mi_new.setAttribute("oncommand", "InFormEnter.OnProfileCurrent(" + profileData[1] + ");");
  if (profileCurrentId == profileData[1])
   mi_new.setAttribute("checked", true);
  mi_profile.parentNode.appendChild (mi_new);
 }
},

//------------------------------------------------------------------------------
ShowCurrentState: function() 
{
 // Read state
 InFormEnterCommon.ReadState();

 // On\Off
 var sbpi = document.getElementById('informenter-status');
 sbpi.setAttribute("status", InFormEnterCommon.g_IsOn ? "on" : "off");
 sbpi.setAttribute("tooltip", InFormEnterCommon.g_IsOn ? "informenter-tooltip-on" : "informenter-tooltip-off" );

 // Options Placement
 document.getElementById('informenter-status').setAttribute("hidden", InFormEnterCommon.g_OptionsPlacement==0 ? "false" : "true");
 document.getElementById('informenter-menu').setAttribute("hidden", InFormEnterCommon.g_OptionsPlacement==1 ? "false" : "true");

 // Context menu
 var menu = document.getElementById("contentAreaContextMenu");
 menu.addEventListener("popupshowing", InFormEnter.OnContextPopupShowing, false);
},

//------------------------------------------------------------------------------
OnStatusClick: function(event) 
{
 if (event.button == 2) // right mouse click
 {
  InFormEnterCommon.g_IsOn = !InFormEnterCommon.g_IsOn;
  InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.On", InFormEnterCommon.g_IsOn);
  InFormEnter.ProcessPage(null, "load");
  return;
 }
},

//------------------------------------------------------------------------------
// Floating markers

CheckActiveMarker: function()
{
 if (InFormEnter.m_ActiveMarkers.length && InFormEnter.m_IsActiveMarker == false)
 {
  for (var i=InFormEnter.m_ActiveMarkers.length-1; i>=0; i--)
   InFormEnter.m_ActiveMarkers[i].setAttribute("style", InFormEnter.m_AutofloatStyleHide);
  InFormEnter.m_ActiveMarkers = [];
  InFormEnter.m_IsActiveMarker = false;
 }
},

RegisterPageEventers: function(windowCurrent)
{
 // Process self frame //
 var doc = windowCurrent.document;

 var dw = new XPCNativeWrapper (doc.defaultView).wrappedJSObject;

 dw.ife_OnInputOver = function (event)
 {
  if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
  {
   event.target.nextSibling.setAttribute("style", InFormEnter.m_AutofloatStyleShow);

   // Variant 1 - abs position 
   //var point = InFormEnterCommon.GetElementXY (event.target);
   //var x = point.x + event.target.offsetWidth - event.target.nextSibling.offsetWidth - 1;
   //var y = point.y + event.target.offsetHeight - event.target.nextSibling.offsetHeight - 1;
   
   // Variant 2 - abs position 
   //var rect = event.target.getBoundingClientRect();
   //var x = parseInt(rect.right) - event.target.nextSibling.offsetWidth - 1;
   //var y = parseInt(rect.top) - 1;

   // Variant 3 - relative position
   var x = - event.target.nextSibling.offsetWidth - 1;
   var y = 0;
   
   event.target.nextSibling.style.left = x+"px";
   event.target.nextSibling.style.top = y+"px";
   //var rect = event.target.getBoundingClientRect();
   //event.target.setAttribute("title", x1+":"+x+"; "+y1+":"+y);  
   var fieldHeight = event.target.offsetHeight;
   if(fieldHeight > 0 && fieldHeight < 19) // to fix facebook bug
    event.target.nextSibling.style.height = fieldHeight+"px";

   InFormEnter.m_IsActiveMarker = true;
   InFormEnter.m_ActiveMarkers.push(event.target.nextSibling);
  }
 }

 dw.ife_OnInputOut = function ()
 {
  if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
  {
   InFormEnter.m_IsActiveMarker = false;
   window.setTimeout("InFormEnter.CheckActiveMarker();", 200);
  }
 }

 dw.ife_OnMarkerOver = function ()
 {
  if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
  {
   InFormEnter.m_IsActiveMarker = true;
  }
 }

 dw.ife_OnMarkerOut = function ()
 {
  if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
  {
   InFormEnter.m_IsActiveMarker = false;
   window.setTimeout("InFormEnter.CheckActiveMarker();", 200);
  }
 }

 // Process subframes //
 for (var i=0; i<windowCurrent.frames.length; i++)
  InFormEnter.RegisterPageEventers(windowCurrent.frames[i]);
},

//------------------------------------------------------------------------------
AttachMarker: function(doc,field,checkFormCache) 
{
 var markerNeed = false;

 if (field.nextSibling != null)
 {
  try   
  {
   var className = field.nextSibling.getAttribute("class");
   if (className.indexOf ("ife_marker") == -1)
    markerNeed = true;
  }
  catch (e)
  {
   markerNeed = true;
  }
 }
 else
  markerNeed = true;

 if (markerNeed)
 {
  // field
  //field.setAttribute("title", "marginRight="+field.style.marginRight);
  field.style.marginRight = "0px";
  field.style.paddingRight = "0px";
 
  // img
  var imgNode = doc.createElement("img");
  imgNode.setAttribute("id", field.getAttribute("name") + "_ife_marker_" + InFormEnter.m_MarkerNumber);
  if(checkFormCache && InFormEnterCommon.g_FormHistory && InFormEnterCommon.g_IsOn && InFormEnterCommon.g_ColorizeItems)
  {
    var itemsCount = InFormEnterCommon.GetCurrentProfileItemsCountInFormCache(field.name);
    if(itemsCount > 1)
     imgNode.setAttribute("src", "chrome://informenter/skin/marker_inhistory.png");
    if(itemsCount == 1)
     imgNode.setAttribute("src", "chrome://informenter/skin/marker_inhistory_one.png");
    if(itemsCount == 0)
     imgNode.setAttribute("src", "chrome://informenter/skin/marker.png");
  }
  else
   imgNode.setAttribute("src", "chrome://informenter/skin/marker.png");

  imgNode.setAttribute("class", "ife_marker"); 
  var styleAttribute = "position:relative; z-index: 999; cursor:pointer; vertical-align: bottom; border: 0; width: 14px; height: ";
  var fieldHeight = field.offsetHeight;
  if(fieldHeight > 0 && fieldHeight < 19) // to fix facebook bug
   styleAttribute += fieldHeight;
  else 
   styleAttribute += "19"; // 19 is height of marker picture
  styleAttribute += "px;";
  
  if (InFormEnterCommon.g_MarkersMode < 0) // disable markers
   styleAttribute += " display:none;";
  if (InFormEnterCommon.g_MarkersMode == 1 || InFormEnterCommon.g_MarkersMode == 2)  
   styleAttribute += " display:inline;";
  if(InFormEnterCommon.g_MarkersMode < 3) // not autofloat markers
  {
   imgNode.setAttribute("style", styleAttribute);
   //imgNode.setAttribute("align", "baseline");
  }

  var maxlength = field.getAttribute("maxlength");
  imgNode.setAttribute("title", InFormEnterCommon.StrMaxInputLength (maxlength));
  
  // Variant Old
  field.parentNode.insertBefore (imgNode, field.nextSibling);
  /*
  if(typeof field.parentNode.style == "undefined")
	field.parentNode.setAttribute("style", "white-space: nowrap !important;");
  else
    field.parentNode.style = field.parentNode.style + " white-space: nowrap !important;";
  */ // bad idea - not work 	
  // Variant Old

  // Variant New
  /*
  var spanNode = doc.createElement("span");
  spanNode.setAttribute("style", "white-space: nowrap !important;");
  var fieldParentNode = field.parentNode;
  fieldParentNode.insertBefore (spanNode, field.nextSibling);
  fieldParentNode.removeChild(field);
  spanNode.appendChild(field);
  spanNode.appendChild(imgNode);
  */
  //
  // It was a good idea, but after this DOM change 
  // FF 6.0.2 does lost access to objects like document.form_search_advance.q
  // (document.form_search_advance.q is 'undefined')
  // 
  // Variant New
  
  // MM==2
  if(InFormEnterCommon.g_MarkersMode == 2) // reduce inputs width
  {
   var newWidth = field.offsetWidth;
   if (newWidth >= 36)
   {
    newWidth -= 18; 
	field.style.width = newWidth+"px"; 
   }
  }

  // MM==3
  if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
  {
   field.setAttribute("onmouseover", "ife_OnInputOver(event);");
   field.setAttribute("onmouseout", "ife_OnInputOut();");

   imgNode.setAttribute("style", InFormEnter.m_AutofloatStyleHide);

   imgNode.setAttribute("onmouseover", "ife_OnMarkerOver();");
   imgNode.setAttribute("onmouseout", "ife_OnMarkerOut();");
  }

  // 
  InFormEnter.m_MarkerNumber++;
 }
},

//------------------------------------------------------------------------------
AddMarkers: function(windowCurrent) 
{
 // Process self frame //
 var doc = windowCurrent.document;
 var inputs = doc.getElementsByTagName("input");

 // markers to inputs
 for (var i=0; i<inputs.length; i++)
 {
  var input = inputs[i];
  var type = input.getAttribute("type");
  if(type != null)
   type = type.toLowerCase();
  if (type == null || type == "" || type == "text" || type == "password" || type == "search")
  {
   if(InFormEnterCommon.IsInputVisibleAndEditable(input))
    InFormEnter.AttachMarker(doc,input,true);
  }
 }

 // markers to textareas
 inputs = doc.getElementsByTagName("textarea");
 for (i=0; i<inputs.length; i++)
 {
  if(InFormEnterCommon.IsInputVisibleAndEditable(inputs[i]))
   InFormEnter.AttachMarker(doc,inputs[i],false);
 }

 // Process subframes //
 for (i=0; i<windowCurrent.frames.length; i++)
  InFormEnter.AddMarkers(windowCurrent.frames[i]);
},

//------------------------------------------------------------------------------
RemoveMarkers: function(windowCurrent) 
{
 // Process self frame //
 var doc = windowCurrent.document;

 var images = doc.getElementsByTagName("img");
 for (var i=images.length-1; i>=0; i--)
 {
  var image = images[i];
  var className = image.getAttribute("class");
  if (className != null && className.indexOf("ife_marker") != -1)
   image.parentNode.removeChild (image);
 }

 // Process subframes //
 for (i=0; i<windowCurrent.frames.length; i++)
  InFormEnter.RemoveMarkers(windowCurrent.frames[i]);
},

//------------------------------------------------------------------------------
ProcessPage: function(event, event_type) 
{
 // check double events
 var breakProcess = 0;
 var ife_current_href = window._content.document.location.href.toString();

 if(event_type == "load")
 {
  var ife_loaded_href = "";
  if(event != null)
  {
   event.originalTarget.ife_document_is_loaded = 1;
   ife_loaded_href = event.originalTarget.location.href.toString();
   
   //if(ife_current_href != ife_loaded_href) // frames!
   // breakProcess = 1;
  }
 }
 var ife_document_is_loaded = window._content.document.ife_document_is_loaded;

 if(event_type == "focus")
 {
  if(ife_document_is_loaded && ife_current_href == InFormEnter.m_LastFocusURL) // #1=repeated next focusing 
   breakProcess = 1;
  if(!ife_document_is_loaded) // #2=repeated previous focusing
   breakProcess = 1;
  
  InFormEnter.m_LastFocusURL = ife_current_href;
 }

 if(breakProcess)
  return;

 //ddd("ProcessPage:"+event_type+"; "+ife_current_href);

 // page process 
 InFormEnter.m_MarkerNumber = 0;
 if (InFormEnterCommon.g_IsOn)
 {
  InFormEnter.AddMarkers(window._content);
  window.onclick=InFormEnter.CheckMarkerClick;
  window.ondblclick=InFormEnter.CheckMarkerDoubleClick;

  if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
  {
   if(InFormEnter.m_MarkerNumber > 0) // markers rebuilded
   {
    InFormEnter.m_IsActiveMarker = false;
    InFormEnter.m_ActiveMarkers = [];
   }
   InFormEnter.RegisterPageEventers(window._content);
  }
 }
 else
  InFormEnter.RemoveMarkers(window._content); 

 InFormEnter.ShowCurrentState();
}

};

//------------------------------------------------------------------------------
window.addEventListener("DOMContentLoaded",function(event) {InFormEnter.ProcessPage(event, "load");},true);
//window.addEventListener("load", function(event) {InFormEnter.ProcessPage(event, "load"); },true);
window.addEventListener("focus",function(event) {InFormEnter.ProcessPage(event, "focus");},true);
