var InFormEnterOptions = {

//------------------------------------------------------------------------------
m_profiles : new Array(),
m_currentId : 0,
m_OptionsLoaded : 0,

//------------------------------------------------------------------------------
indexOfProfileId: function(profileId) 
{
 var index = 0;
 for (var i=0; i<this.m_profiles.length; i++)
 {
  if (this.m_profiles[i][1] == profileId)
  {
   index = i;
   break;
  }
 }
 return index;
},

//------------------------------------------------------------------------------
profilesListFill: function(et_list) 
{
 while (et_list.hasChildNodes())
  et_list.removeChild (et_list.firstChild);

 for (var i=0; i<this.m_profiles.length; i++)
 {
  if (this.m_profiles[i][1] > 0)
  {
   var newItem = et_list.appendItem(this.m_profiles[i][0]);
   newItem.setAttribute("id", this.m_profiles[i][1]);
  }
 }
},

//------------------------------------------------------------------------------
profileListSelect: function(et_list, profileId) 
{
 var menu_items=et_list.firstChild.childNodes;
 for (var i=0;i<menu_items.length;i++) 
 {
  if (menu_items[i].getAttribute("id")==profileId) 
  {
   et_list.selectedIndex=i;
   break;
  }
 }
},

//------------------------------------------------------------------------------
buttonDelValidate: function(et_list) 
{
 var menu_items = et_list.firstChild.childNodes;
 var et_del = document.getElementById("ife_profile_del");
 et_del.setAttribute ("disabled", menu_items.length <= 1);
},

//------------------------------------------------------------------------------
profileNextNumCreate: function() 
{
 var result = InFormEnterCommon.GetPrefInt("InFormEnter.ProfileNext", 1);
 var nextNum = result;
 if (nextNum < 32000)
  nextNum++;
 else
  nextNum = 0;
 InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.ProfileNext", nextNum);
 return result;
},

//------------------------------------------------------------------------------
OnOptionsLoad: function()  
{
 InFormEnterCommon.CheckDefaultProfile();

 ///// Profiles /////
 InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.Options", 1); // lame options update

 // profiles list
 var profilesArr = InFormEnterCommon.GetPrefChar("InFormEnter.Profiles", "").split("\n");
 var profiles_new = new Array();
 for (var i=0; i<profilesArr.length; i++)
 {
  var tmp = profilesArr[i].split("\t");
  var profileName = unescape(tmp[0]);
  var profileId = tmp[1];
  var menuSet = unescape(InFormEnterCommon.GetPrefChar("InFormEnter."+profileId+".MenuSet", ""));
  var showSize = InFormEnterCommon.GetPrefInt("InFormEnter."+profileId+".ShowSize", 0);
  var profile = new Array(profileName, profileId, menuSet, showSize);
  profiles_new.push(profile);
 }
 this.m_profiles = profiles_new;

 var et_list = document.getElementById("ife_profile_menu");
 this.profilesListFill(et_list); 
 this.profileListSelect(et_list, InFormEnterCommon.GetPrefInt("InFormEnter.ProfileCurrent", 1));

 this.buttonDelValidate(et_list);
 this.OnProfileSelect();

 ///// Other options /////
 var et_enable = document.getElementById("ife_options_enable");
 et_enable.checked = InFormEnterCommon.GetPrefInt("InFormEnter.On", 1);

 InFormEnterCommon.g_MarkersMode = InFormEnterCommon.GetPrefInt("InFormEnter.MarkersMode", 1);
 var et_MEnable = document.getElementById("ife_marker_enable");
 et_MEnable.checked = InFormEnterCommon.g_MarkersMode > 0;

 if (InFormEnterCommon.g_MarkersMode < 0)
  InFormEnterCommon.g_MarkersMode *= -1;
 
 var et_MMode = document.getElementById("ife_marker_mode");
 et_MMode.value = InFormEnterCommon.g_MarkersMode;

 this.OnEnableMarkers();

 var et_Colorize = document.getElementById("ife_colorize_enable");
 var colorize = InFormEnterCommon.GetPrefInt("InFormEnter.ColorizeItems2", 0);
 if(!InFormEnterCommon.g_FormHistory) // no interface
  colorize = 0;
 et_Colorize.checked = colorize;
 et_Colorize.setAttribute ("disabled", !InFormEnterCommon.g_FormHistory);

 var et_placement = document.getElementById("ife_options_placement");
 et_placement.selectedIndex = InFormEnterCommon.GetPrefInt("InFormEnter.OptionsPlacement", 0);

 var et_MRClick = document.getElementById("ife_options_marker_right_click");
 et_MRClick.selectedIndex = InFormEnterCommon.GetPrefInt("InFormEnter.MarkerRightClick", 0);

 ///// Finalize /////
 this.m_OptionsLoaded = 1;
 var et_text = document.getElementById("ife_options_text");
 et_text.focus();

 return true;
},

//------------------------------------------------------------------------------
OnOptionsUnload: function() 
{
 if (this.m_OptionsLoaded)
 {
  window.focus();
  if (window.confirm (InFormEnterCommon.GetPropStr("ife.msg.save")))
    this.OnOptionsAccept(false);
 }
 else
  InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.Options", 0); // lame options update

 return true;
},

//------------------------------------------------------------------------------
OnProfileSelect: function()
{
 var index;
 var et_text = document.getElementById("ife_options_text");
 var et_showsize = document.getElementById("ife_options_showsize");

 // save old
 if (this.m_currentId != 0)
 {
  index = this.indexOfProfileId(this.m_currentId);
  this.m_profiles[index][2] = et_text.value;
  this.m_profiles[index][3] = et_showsize.checked;
 }

 // show new 
 var et_list = document.getElementById("ife_profile_menu");
 var menu_items = et_list.firstChild.childNodes;
 var id = menu_items[et_list.selectedIndex].getAttribute("id");
 this.m_currentId = id;

 index = this.indexOfProfileId(id);
 et_text.value = this.m_profiles[index][2];
 et_showsize.checked = this.m_profiles[index][3];

 return true;
},

//------------------------------------------------------------------------------
OnProfileAdd: function()
{
 var profileName = InFormEnterCommon.GetPropStr("ife.default.profile.new");

 // prompt service
 var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
 var profileObj = new Object();
 var checkObj = new Object();
 profileObj.value=profileName;
 if(promptService.prompt(window,InFormEnterCommon.GetPropStr("ife.prompt.ap.caption"), InFormEnterCommon.GetPropStr("ife.prompt.ap.text"), profileObj, null, checkObj) && 
    profileObj.value.length > 0) 
   profileName=profileObj.value;
 else
   return true;
 
 var profileId = this.profileNextNumCreate();
 this.m_profiles.push (new Array(profileName, profileId, "", 0));
 var et_list = document.getElementById("ife_profile_menu");
 this.profilesListFill(et_list); 
 this.profileListSelect(et_list, profileId);

 this.buttonDelValidate(et_list);
 this.OnProfileSelect();

 return true;
},

//------------------------------------------------------------------------------
OnProfileRename: function()
{
 // current 
 var et_list = document.getElementById("ife_profile_menu");
 var menu_items = et_list.firstChild.childNodes;
 var profileName = menu_items[et_list.selectedIndex].getAttribute("label");

 // prompt service
 var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
 var profileObj = new Object();
 var checkObj = new Object();
 profileObj.value=profileName;
 if(promptService.prompt(window,InFormEnterCommon.GetPropStr("ife.prompt.rp.caption"), InFormEnterCommon.GetPropStr("ife.prompt.rp.text"), profileObj, null, checkObj) && 
    profileObj.value.length > 0) 
   profileName=profileObj.value;
 else
   return true;

 var index = this.indexOfProfileId(this.m_currentId);
 this.m_profiles[index][0] = profileName;
 this.profilesListFill(et_list); 
 this.profileListSelect(et_list, this.m_currentId);

 return true;
},

//------------------------------------------------------------------------------
OnProfileDel: function()
{
 var et_list = document.getElementById("ife_profile_menu");
 var menu_items = et_list.firstChild.childNodes;
 var id = menu_items[et_list.selectedIndex].getAttribute("id");

 var profileIdToSelect = 0;
 var profileDeleted = false;
 for (var i=0; i<this.m_profiles.length; i++)
 {
  var profileId = this.m_profiles[i][1];
  if (profileId == id)
  {
   this.m_profiles[i][1] = -id;
   profileDeleted = true;
  }
  else
  {
   if (profileId > 0 && profileIdToSelect == 0)
    profileIdToSelect = profileId;
  }

  if (profileIdToSelect > 0 && profileDeleted)
   break;
 }
 this.m_currentId = 0; // don`t save

 this.profilesListFill(et_list); 
 this.profileListSelect(et_list, profileIdToSelect);

 this.buttonDelValidate(et_list);
 this.OnProfileSelect();

 return true;
},

//------------------------------------------------------------------------------
OnEnableMarkers: function()
{
 var et_MEnable = document.getElementById("ife_marker_enable");
 //et_MEnable.checked
 var et_MMode = document.getElementById("ife_marker_mode");
 et_MMode.disabled = !et_MEnable.checked;
},

//------------------------------------------------------------------------------
OnWarningColorize: function()
{
 var et_Colorize = document.getElementById("ife_colorize_enable");
 if (et_Colorize.checked)
  alert (InFormEnterCommon.GetPropStr("ife.msg.warning.colorize"));
},

//------------------------------------------------------------------------------
OnOptionsAccept: function(toCloseWindow) 
{
 ///// Profiles /////
 // current profile data
 var index = this.indexOfProfileId(this.m_currentId);
 var et_text = document.getElementById("ife_options_text");
 var et_showsize = document.getElementById("ife_options_showsize");

 this.m_profiles[index][2] = et_text.value;
 this.m_profiles[index][3] = et_showsize.checked;

 // all profiles
 var profilesStr = "";
 for (var i=0; i<this.m_profiles.length; i++)
 {
  var profileId = this.m_profiles[i][1];
  if (profileId > 0) 
  {
   // to save profile
   var profileName = this.m_profiles[i][0];
   var menuSet = this.m_profiles[i][2];
   var showSize = this.m_profiles[i][3];
   
   //
   if (profilesStr != "")
    profilesStr += "\n";
   profilesStr += (escape(profileName) + "\t" + profileId);

   //  
   InFormEnterCommon.g_Preferences.setCharPref("InFormEnter."+profileId+".MenuSet", escape(menuSet));
   InFormEnterCommon.g_Preferences.setIntPref("InFormEnter."+profileId+".ShowSize", showSize);
  }
  else
  {
   // to delete profile
   InFormEnterCommon.g_Preferences.deleteBranch ("InFormEnter."+profileId+".MenuSet");
   InFormEnterCommon.g_Preferences.deleteBranch ("InFormEnter."+profileId+".ShowSize");
  }
 }
 InFormEnterCommon.g_Preferences.setCharPref("InFormEnter.Profiles", profilesStr);

 // current Id
 if (this.m_currentId != 0)
  InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.ProfileCurrent", this.m_currentId);

 ///// Other options /////
 var et_enable = document.getElementById("ife_options_enable");
 InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.On", et_enable.checked);

 var et_MEnable = document.getElementById("ife_marker_enable");
 var et_MMode = document.getElementById("ife_marker_mode");
 InFormEnterCommon.g_MarkersMode = et_MMode.value;
 if (!et_MEnable.checked)
  InFormEnterCommon.g_MarkersMode *= -1;

 InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.MarkersMode", InFormEnterCommon.g_MarkersMode);

 var et_Colorize = document.getElementById("ife_colorize_enable");
 InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.ColorizeItems2", et_Colorize.checked);

 var et_placement = document.getElementById("ife_options_placement");
 InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.OptionsPlacement", et_placement.selectedIndex);

 var et_MRClick = document.getElementById("ife_options_marker_right_click");
 InFormEnterCommon.g_Preferences.setIntPref("InFormEnter.MarkerRightClick", et_MRClick.selectedIndex);

 ///// Finalize /////
 this.m_OptionsLoaded = 0;
 
 if (toCloseWindow)
  window.close();

 return true;
},

//------------------------------------------------------------------------------
OnOptionsCancel: function() 
{
 this.m_OptionsLoaded = 0;
 window.close();
 return true;
}

};